function Element() {
    this.img = this.speed = this.y = this.x = this.height = undefined;
    this.points = this.minusSpeed = this.width = this.image = undefined;

    this.setParameters();
    this.setView();
}

Element.prototype.setParameters = function() {
    this.speed = settings.START_ELEMENTS_SPEED + Math.round(Math.random() * (settings.VARIATIVE_ELEMENTS_SPEED * 2)) - settings.VARIATIVE_ELEMENTS_SPEED;
    var yRange = constants.GAME_HEIGHT - settings.FISHES_START_Y - (constants.GAME_HEIGHT - settings.FISHES_END_Y);
    this.y = Math.round(Math.random() * yRange) + settings.FISHES_START_Y;
    this.x = 0 - settings.FISHES_SPAWN_X;
    if(Math.random() > 0.5) {
        this.x = constants.GAME_WIDTH + settings.FISHES_SPAWN_X;
        this.speed *= -1;
    }

    var index = Math.round(Math.random() * (settings.ELEMENTS.length - 1));
    this.points = settings.ELEMENTS[index][settings.pointsParameter];
    this.width = settings.ELEMENTS[index][settings.widthParameter];
    this.minusSpeed = settings.ELEMENTS[index][settings.minusSpeedParameter];
    this.image = variables.elementsImages[index];
}

Element.prototype.setView = function() {
    this.img = new paper.Raster(this.image);
    this.img.size.width = this.width;
    this.img.size.height = this.image.height * (this.width / this.image.width);
    this.img.position = new paper.Point(this.x, this.y);
    if(this.speed < 0) {
        this.img.scale(-1, 1);
    }
}

Element.prototype.isCached = function(bobberPoint) {
    var x1 = this.speed > 0 ? this.img.position.x - this.img.size.width / 6 : this.img.position.x - this.img.size.width / 2;
    var x2 = this.speed > 0 ? this.img.position.x + this.img.size.width / 2 : this.img.position.x + this.img.size.width / 6;
    var y1 = this.img.position.y - this.img.size.height / 6;
    var y2 = this.img.position.y + this.img.size.height / 2;

    if(bobberPoint.x > x1 && bobberPoint.x < x2 && bobberPoint.y > y1 && bobberPoint.y < y2) return true;
    return false;
}

Element.prototype.onFrame = function() {
    this.img.position.x += this.speed;
    if(this.img.position.x < 0 - settings.FISHES_SPAWN_X || this.img.position.x > constants.GAME_WIDTH + settings.FISHES_SPAWN_X) {
        $(this).trigger(events.ELEMENT_OUT);
    }
}

Element.prototype.clear = function() {
    if(typeof (this.img) != "undefined") {
        this.img.remove();
        this.img = undefined;
    }
}